#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/init.h>      /* for module_init/exit */
#include <linux/proc_fs.h>
#include <linux/module.h>
#include <linux/version.h>
#include <linux/types.h>


extern char last_kernel_trap[1024];
extern char last_user_trap[1024];
extern unsigned long kerneltraps;
struct proc_dir_entry *trap_proc_entry;


static int trap_proc_output(char *buffer, int bufsize)
{
        int i,bufpos=0;
        if (bufsize<4096)
        	return 0;        
        bufpos += sprintf(buffer+bufpos,"Last userland trap : %s",last_user_trap);
        bufpos += sprintf(buffer+bufpos,"Last kernel trap   : %s",last_kernel_trap);
        bufpos += sprintf(buffer+bufpos,"Kernel trap count  : %li\n",kerneltraps);
	return bufpos;
}






static int trap_read_proc(char *page, char **start, off_t off,
                         int count, int *eof, void *data)
{
        int len = trap_proc_output (page,4096);
        if (len <= off+count) *eof = 1;
        *start = page + off;
        len -= off;
        if (len>count) len = count;
        if (len<0) len = 0;
        return len;
}

int trap_module_init(void)
{        
        /* /proc/unallignedinfo probably isn't the best place for it, need
           to find a better one */
	trap_proc_entry = create_proc_entry ("unalignedinfo", 0, NULL);
	if (trap_proc_entry==NULL)
		return -EIO;

	trap_proc_entry->read_proc = trap_read_proc;
	trap_proc_entry->owner = THIS_MODULE;

	return 0;
}


void trap_module_exit(void)
{
	 remove_proc_entry ("unalignedinfo", trap_proc_entry);
}

module_init(trap_module_init);
module_exit(trap_module_exit);

